<?php
namespace Dfe\TBCBank;
use Df\Payment\Init\Action;
// 2018-09-26
/** @method Method m() */
final class Charge extends \Df\Payment\Charge {
	/**
	 * 2018-09-27
	 * @return array(string => mixed)
	 */
	private function pCharge() {$c = Action::sg($this->m())->preconfiguredToCapture(); return [
		// 2018-09-26 «transaction amount in fractional units, mandatory (up to 12 digits)»
		'amount' => $this->amountF()
		// 2018-09-26 «client’s IP address, mandatory (15 characters)»
		,'client_ip_addr' => df_visitor_ip()
		 // 2018-09-26 «identifies a request for transaction registration»
		,'command' => $c ? 'v' : 'a'
		// 2018-09-26 «transaction currency code (ISO 4217), mandatory, (3 digits)»
		,'currency' => df_currency_num($this->currencyC())
		,'description' => 'UFCTEST' // 2018-09-26 «transaction details, optional (up to 125 characters)»
		/**
		 * 2018-10-06
		 * «SMS» means «Single Message System» (the «preauthorize and capture» action).
		 * «DMS» means «Dual Message System» (the «preauthorize only» action).
		 *
		 * «Procedure for processing transactions in one stage is called Single Message System (SMS).
		 * When using this system, withdrawal of funds from buyer’s card is done in 1 operation:
		 * request for authorization sent to issuer bank
		 * at the same time constitutes a financial confirmation of the payment.
		 * Therefore when acquirer bank receives a signal via payment system
		 * that authorization is confirmed, transaction is considered closed.
		 *
		 * Two-stage technology to process a transaction, known as Dual Message System (DMS),
		 * is slightly different from the first option.
		 * This system separates authorization from settlements as different software procedures.
		 * Preauth procedure that blocks the necessary amount on a client’s card account,
		 * and Capture procedure that debits the account may be apart for 7 to 28 days.»
		 * https://www.linkedin.com/pulse/sms-dms-procedure-process-transaction-ramalingom-sundaram-pillai
		 */
		,'msg_type' => $c ? 'SMS' : 'DMS'
	];}

	/**
	 * 2018-09-27
	 * @used-by \Dfe\TBCBank\Session::init()
	 * @param Method|null $m [optional]
	 * @return array(string => mixed)
	 */
	static function p(Method $m = null) {return (new self($m ?: dfpm(__CLASS__)))->pCharge();}
}